// prodotto scalare
#define DotProduct(a, b)	((a).x * (b).x + (a).y * (b).y + (a).z * (b).z)

// riduci vettore a norma 1
void Normalize(Vector3D *v);
void Normalize2D(Vector2D *v);
// prodotto vettoriale
void CrossProduct(Vector3D a, Vector3D b, Vector3D *out);
// norma di un vettore
float VectorModule(Vector3D v);
// prodotto di vettore per scalare
void VectorMult(Vector3D *v, float value);
// proiezione di vettore su un piano
float ProjectVector(Vector3D *v, Vector3D *pd, Vector3D *pn, Vector3D *out);

int PointTouchesPoly(Point3D *p, Polygon3D *poly);
